breed [ reds a-red ]
breed [ greens a-green ]

turtles-own [ stuck ]

;;;
;;; PROCEDURY TLATKA PIPRAV
;;;

to setup
  clear-all
  set-default-shape turtles "circle"
  setup-patches
  create-molecules 400 reds red
  create-molecules 400 greens green
end

to setup-patches
  draw-absorber
  erode
  draw-walls
end

to draw-absorber
  ask patches
    [ if abs pycor < tloustka-media
        [ set pcolor blue ]
      ;; pokud je zapnut STENOVY-EFEKT?, vytvo dva przdn prostory pobl okraje okna modelu
      if stenovy-efekt? and ( pxcor > (max-pxcor - 15) or pxcor < (min-pxcor + 15) )
        [ set pcolor black ] ]
end

to draw-walls
  ask patches
    [ if patch-at 3 0 = nobody or patch-at -3 0 = nobody
        [ set pcolor (violet - 1) ] ]
end

to erode
  crt pocet-poru
    [ setxy random-xcor tloustka-media
      dig-tunnel 180 90 ]
end

; tunely (pry v mdiu) jsou prokopny pomoc nhodnho pohybu
to dig-tunnel [direction wiggle]  ;; procedura elv
  loop
    [ if ycor < (- tloustka-media)
        [ die ]
      set heading direction + wiggle - 2 * random-float wiggle
      set pcolor black
      fd 1
      set pcolor black
      fd 1 ]
end

to create-molecules [number new-breed new-color]
  crt number
    [ set xcor (max-pxcor - 3) - random-float (2 * (max-pxcor - 3))
      set ycor tloustka-media + random-float (max-pycor - tloustka-media)
      set breed new-breed
      set color new-color
      set stuck 0 ]
end

;;;
;;; PROCEDURY TLATKA START
;;;

to go
  if not any? turtles
    [ stop ]
  ask turtles
    [ if patch-at 0 -1 = nobody
        [ die ]
      wander ]
  tick
  do-plot
end

;; erven molekuly jsou inertn a nelep se k modrm polk (mdiu).
;; Zelen molekuly se na povrch lep. Kdy se zelen molekula dotkne 
;; modrho polka pilep se k nmu na dobu odpovdajc promnn PRILNAVOST.
;; Tato hodnota se v kadm asovm kole sn o jedna. Kdy doshne nuly, 
;; tak se molekula opt odlep.

to wander
  set heading (270 - random-float 180)
  ifelse stuck = 0
    [ if ([pcolor] of patch-ahead 1) = black
        [ fd 1 ]
      let p patch-ahead 1
      if p = nobody [ die ]
      if (breed = greens) and (([pcolor] of p) = blue)
        [ set stuck prilnavost ] ]
    [ set stuck stuck - 1 ]
end

;;;
;;; PROCEDURY GRAF
;;;

;; Potebujeme spotat koncentraci ervench a zelench stic,
;; kter proly absorbujc ltkou
to do-plot
  set-current-plot "Vstupy plyn"

  set-current-plot-pen "erven"
  let reds-out (count reds with [ycor < (- tloustka-media)])
  plot (100 * reds-out) / 400

  set-current-plot-pen "zelen"
  let greens-out (count greens with [ycor < (- tloustka-media)])
  plot (100 * greens-out) / 400
end


; Copyright 1998 Uri Wilensky. All rights reserved.
; The full copyright notice is in the Information tab.
@#$#@#$#@
GRAPHICS-WINDOW
256
10
779
554
85
85
3.0
1
10
1
1
1
0
0
0
1
-85
85
-85
85
1
1
1
ticks

CC-WINDOW
5
568
788
663
Command Center
0

PLOT
3
200
246
404
Vstupy plyn
as
Molekuly
0.0
500.0
0.0
25.0
true
false
PENS
"erven" 1.0 0 -2674135 true
"zelen" 1.0 0 -10899396 true

SLIDER
8
46
188
79
tloustka-media
tloustka-media
1.0
40.0
16
1.0
1
NIL
HORIZONTAL

SLIDER
8
82
188
115
pocet-poru
pocet-poru
0.0
120.0
70
1.0
1
NIL
HORIZONTAL

SLIDER
8
160
189
193
prilnavost
prilnavost
0.0
10.0
5
1.0
1
NIL
HORIZONTAL

SWITCH
31
10
171
43
stenovy-efekt?
stenovy-efekt?
1
1
-1000

BUTTON
24
121
95
154
Piprav
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
100
121
169
154
Start
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

@#$#@#$#@
CO TO JE?
---------

Toto je model chromatografie plynu. Vtina modern chemie zvis na chromatografi kvli poteb oddlovn (separace) jednotlivch chemickch ltek. Chromatografie plynu je pouze jedna z forem chromatografie, kter se tk plyn. Chromatografie doke bt tak citliv, e s jej pomoc lze oddlovat dokonce i enantiomery (to jsou molekuly, kter jsou tm identick a li se pouze ve sv zrcadlov obrcen orientaci).

Chromatografie oddluje chemick ltky za pouit interakc s rznmi povrchy. Mylenka je prost. Rzn chemick ltky maj odlin zpsoby pohybu skrze mal prostory (napklad z dvodu jejich rozdln velikosti) a odlinou schopnost pilnavosti k povrchm. To lze pozorovat v kadodennm ivot. Napklad pokud nanesete kapku vody a kapku lepidla na ikmou plochu, voda stee dol, zatmco lepidlo zstane tam, kde bylo. Jednotliv molekuly se tak li ve sv pilnavosti k povrchm. Napklad vodn pra se sr (kondenzuje) na studenm skle, zatmco vzdun kyslk takto nereaguje. Je tomu tak proto, e vazba kyslku na sklo nen dostaten siln, aby zde kyslk udrela. Odtud ji vede pouze mal krok k mylence o vyuit rozdln pilnavosti molekul k jejich vzjemn separaci.

V praxi jsou pi chromatografii molekuly plynu donuceny k prchodu skrze porzn mdium, kter se chov jako pilnav povrch. Porzn mdium je materil s drami (pry) -- podobn jako u vcarskho sru, avak s mikroskopickmi rozmry. Pry dovoluj molekulm proniknout z jedn strany mdia na druhou.

Modr oblast uvnit okna modelu pedstavuje porzn mdium. Molekuly zanaj svj pohyb v horn sti a jsou zachycovny v doln sti okna. erven a zelen stice pedstavuj dva odlin druhy molekul. (Pi skuten chromatografii jsou tyto molekuly typicky peneny pomoc inertnho plynu. Tento plyn je pomoc tlaku protlaen mdiem. Chromatografie plynu vak me probhat za pouit jednoduchho oddlovn plyn i bez pomoci penaee.) Molekuly se v tomto modelu pohybuj nhodn smrem dol skrze mdium. erven molekuly se nelep na povrch mdia, zatmco zelen ano. Z hlediska chemie je to dno hned nkolika faktory: interakcemi s povrchem, geometri, velikost molekul atd.

Intenzitu pilnavosti je mon ovldat pomoc pslunho posuvnku. Pokud je napklad pilnavost nastavena na pt, dojde pi kadm dotyku zelench molekul s modrm mdiem k jejich pilnut na pt asovch krok. To zpomal jejich prchod mdiem v porovnn s ervenmi molekulami, co vede k separaci obou ltek.

Tento model se sna tak demonstrovat koncept znm jako stnov efekt. Pokud jsou pobl porznho mdia voln prostory, pak se molekuly mohou tmito prostory pohybovat. To ovem drasticky sniuje kvalitu separace. Przdn prostor blzko stn me bt zpsoben patnou kvalitou mdia nebo nedostatenm utsnnm. 

JAK MODEL OVLDAT
-----------------

Nejdve nastavte porznost modrho materilu pomoc posuvnku POCET-PORU. Mete tak zmnit tlouku absorbujc vrstvy pouvnkem TLOUSTKA-MEDIA. Pepna STENOVY-EFEKT? zapn a vypn stnov efekt popsan ve.

Pro sputn modelu stisknte tlatko START.

Posuvnk PRILNAVOST mn parametr pilnavosti. Vy hodnota pilnavosti zpsob pomalej prchod zelench stic skrze mdium. 

BH MODELU
----------

Program pracuje nejrychleji pi nastaven parametru PRILNAVOST v rozmez mezi hodnotou 3 a 7 v ppad, e POCET-PORU je vt ne 30. Pokud je PRILNAVOST pli vysok nebo POCET-PORU pli nzk, me trvat dlouhou dobu, ne se zelen stice dostanou skrze absorbujc vrstvu. 

VIMNTE SI
-----------

Separace zvis na provitosti materilu. Pokud je pli nzk, pak je absorbujc materil zanesen, ucpn a proces se zastav. Pokud je provitost pli vysok, pak nedochz k dostaten separaci. Tak stnov efekt drasticky sniuje kvalitu separace. 

VYZKOUEJTE SI
--------------

Mete se pokusit vylepit vykreslovn graf. Pi skuten chromatografii je na vstupu zaznamenvna pouze jedin kivka, zobrazujc mru, s jakou molekuly vystupuj z mdia. Je zde zazen nazvan integrtor, kter informuje o mnostv hmoty, kter vychz pi separaci ven.

Pokuste se stejnm zpsobem separovat vce jak dva plyny. 

PROGRAMOVAC ZAJMAVOSTI NETLOGA
--------------------------------

Vimnte si procedury pro vytven pr v mdiu. Funguje na principu paralelnho prokopvn tunel (pr) pomoc nhodnho pohybu.

JAK CITOVAT
-----------
Pi citovn tohoto modelu ve vdeckch publikacch pouijte prosm nsledujc odkaz:
- Wilensky, U. (1998).  NetLogo Gas Chromatography model.  http://ccl.northwestern.edu/netlogo/models/GasChromatography.  Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.
- Wilensky, U. (1999). NetLogo. http://ccl.northwestern.edu/netlogo/. Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.

V jinch publikacch uvete prosm tyto informace:
- Copyright 1998 Uri Wilensky. All rights reserved. See http://ccl.northwestern.edu/netlogo/models/GasChromatography for terms of use.


AUTORSK PRVA
----------------
Copyright 1998 Uri Wilensky. Vechna prva vyhrazena.

Oprvnn pouvat, upravovat nebo dle it tento model je udleno, pokud jsou splnny nsledujc podmnky: 
a) soust modelu jsou (tato) autorsk prva
b) tento model nebude dle en za elem zisku bez povolen autora (Uri Wilensky). 
Pro zskn licence ke komernmu vyuit kontaktujte autora.

Tento model vznikl jako soust projektu: CONNECTED MATHEMATICS: MAKING SENSE OF COMPLEX PHENOMENA THROUGH BUILDING OBJECT-BASED PARALLEL MODELS (PROPOJEN MATEMATIKA: CHPN KOMPLEXNCH JEV SKRZE VYTVEN PARALELNCH MODEL ZALOENCH NA OBJEKTECH). Projekt je podporovn institutem National Science Foundation (Applications of Advanced Technologies Program) -- sla grant RED #9552950 a REC #9632612.

Model byl peveden do jazyka NetLogo jako soust projektu PARTICIPATORY SIMULATIONS: NETWORK-BASED DESIGN FOR SYSTEMS LEARNING IN CLASSROOMS and/or INTEGRATED SIMULATION AND MODELING ENVIRONMENT dky podpoe National Science Foundation (REPP & ROLE programs) -- sla grant REC #9814682 a REC-0126227. Pevedeno z jazyka StarLogoT do jazyka NetLogo v roce 2001.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 4.0.3
@#$#@#$#@
setup
repeat 125 [ go ]
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
