turtles-own [ energy ]
patches-own [ grass ]

breed [cooperative-cows cooperative-cow]
breed [greedy-cows greedy-cow]

to setup
  clear-all
  setup-cows
  ask patches [
    set grass maximalni-vyska-travy
    color-grass
  ]
  do-plotting
end

to setup-cows
  set-default-shape turtles "cow"   ;; aplikovno na oba rody (breed)
  crt pocet-krav [
    setxy random-xcor random-ycor
    set energy metabolismus * 4
    ifelse (random-float 1.0 < pocatecni-procento-spolupracujicich) [
      set breed cooperative-cows
      set color red - 1.5
    ] [
      set breed greedy-cows
      set color sky - 2
    ]
  ]
end

to go
  ask turtles [  ;; zahrnuje oba rody
    move
    eat
    reproduce
  ]
  ask patches [
    grow-grass
    color-grass
  ]
  tick
  do-plotting
end

to reproduce  ;; procedura elv
  if energy > prah-reprodukce [
    set energy energy - cena-reprodukce
    hatch 1
  ]
end

to grow-grass  ;; procedura polek
  ifelse ( grass >= rustovy-prah) [
    if vysoky-rust >= random-float 100
      [ set grass grass + 1 ]
  ][
    if nizky-rust >= random-float 100
      [ set grass grass + 1 ]
  ]
  if grass > maximalni-vyska-travy
    [ set grass maximalni-vyska-travy ]
end

to color-grass  ;; procedura polek
  set pcolor scale-color (green - 1) grass 0 (2 * maximalni-vyska-travy)
end

to move  ;; procedura elv
  rt random 360
  fd delka-kroku
  set energy energy - metabolismus
  if energy < 0 [ die ]
end

to eat  ;; procedura elv
  ifelse breed = cooperative-cows [
    eat-cooperative
  ] [
    if breed = greedy-cows
      [ eat-greedy ]
  ]
end

to eat-cooperative  ;; procedura elv
  if grass > rustovy-prah [
    set grass grass - 1
    set energy energy + energie-travy
  ]
end

to eat-greedy  ;; procedura elv
  if grass > 0 [
    set grass grass - 1
    set energy energy + energie-travy
  ]
end

to do-plotting
  set-current-plot "Vvoj populace krav v ase"
  set-current-plot-pen "Spolupracujc"
  plot count cooperative-cows
  set-current-plot-pen "Nenasytn"
  plot count greedy-cows
end


; *** NetLogo 4.0.2 Model Copyright Notice ***
;
; This model was created as part of the project: CONNECTED MATHEMATICS:
; MAKING SENSE OF COMPLEX PHENOMENA THROUGH BUILDING OBJECT-BASED PARALLEL
; MODELS (OBPML).  The project gratefully acknowledges the support of the
; National Science Foundation (Applications of Advanced Technologies
; Program) -- grant numbers RED #9552950 and REC #9632612.
;
; Copyright 1997 by Uri Wilensky.  All rights reserved.
;
; Permission to use, modify or redistribute this model is hereby granted,
; provided that both of the following requirements are followed:
; a) this copyright notice is included.
; b) this model will not be redistributed for profit without permission
;    from Uri Wilensky.
; Contact Uri Wilensky for appropriate licenses for redistribution for
; profit.
;
; This model was converted to NetLogo as part of the projects:
; PARTICIPATORY SIMULATIONS: NETWORK-BASED DESIGN FOR SYSTEMS LEARNING
; IN CLASSROOMS and/or INTEGRATED SIMULATION AND MODELING ENVIRONMENT.
; The project gratefully acknowledges the support of the
; National Science Foundation (REPP & ROLE programs) --
; grant numbers REC #9814682 and REC-0126227.
; Converted from StarLogoT to NetLogo, 2001.
;
; To refer to this model in academic publications, please use:
; Wilensky, U. (1997).  NetLogo Cooperation model.
; http://ccl.northwestern.edu/netlogo/models/Cooperation.
; Center for Connected Learning and Computer-Based Modeling,
; Northwestern University, Evanston, IL.
;
; In other publications, please use:
; Copyright 1997 Uri Wilensky.  All rights reserved.
; See http://ccl.northwestern.edu/netlogo/models/Cooperation
; for terms of use.
;
; *** End of NetLogo 4.0.2 Model Copyright Notice ***
@#$#@#$#@
GRAPHICS-WINDOW
336
10
661
356
10
10
15.0
1
10
1
1
1
0
1
1
1
-10
10
-10
10
1
1
1
ticks

CC-WINDOW
5
485
670
580
Command Center
0

BUTTON
218
42
273
75
Start
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
38
41
109
74
Piprav
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

SLIDER
7
116
331
149
pocatecni-procento-spolupracujicich
pocatecni-procento-spolupracujicich
0
1.0
0.5
0.01
1
NIL
HORIZONTAL

SLIDER
7
80
154
113
pocet-krav
pocet-krav
0
100
20
1
1
NIL
HORIZONTAL

SLIDER
504
425
661
458
rustovy-prah
rustovy-prah
0.0
99.0
5
1.0
1
NIL
HORIZONTAL

SLIDER
337
392
505
425
vysoky-rust
vysoky-rust
0.0
99.0
70
1.0
1
NIL
HORIZONTAL

SLIDER
155
80
332
113
delka-kroku
delka-kroku
0.0
0.3
0.06
0.01
1
NIL
HORIZONTAL

SLIDER
504
392
661
425
maximalni-vyska-travy
maximalni-vyska-travy
1
40
10
1
1
NIL
HORIZONTAL

SLIDER
7
182
215
215
prah-reprodukce
prah-reprodukce
0.0
200.0
102
1.0
1
NIL
HORIZONTAL

SLIDER
503
359
661
392
energie-travy
energie-travy
0.0
200.0
75
1.0
1
NIL
HORIZONTAL

SLIDER
216
149
332
182
metabolismus
metabolismus
0.0
99.0
6
1.0
1
NIL
HORIZONTAL

SLIDER
337
425
505
458
nizky-rust
nizky-rust
0.0
99.0
30
1.0
1
NIL
HORIZONTAL

SLIDER
7
150
215
183
cena-reprodukce
cena-reprodukce
0.0
99.0
54
1.0
1
NIL
HORIZONTAL

PLOT
7
221
320
401
Vvoj populace krav v ase
as
Krvy
0.0
10.0
0.0
100.0
true
true
PENS
"Nenasytn" 1.0 0 -14985354 true
"Spolupracujc" 1.0 0 -6675684 true

TEXTBOX
134
45
205
73
Zkladn nastaven:
11
0.0
0

TEXTBOX
369
372
483
390
Pokroil nastaven:
11
0.0
0

MONITOR
8
414
134
471
# Spolupracujc
count greedy-cows
1
1
14

MONITOR
143
414
307
471
# Nenasytn
count cooperative-cows
1
1
14

@#$#@#$#@
CO TO JE?
---------

Jedn se o evolun biologick model. Agenti (krvy) soupe o prodn zdroje (trva). Krvy, kter spasou vce trvy, se astji rozmnouj, a jsou proto evolun spnj. Tento model zahrnuje dva druhy krav, nenasytn a spolupracujc. Model ukazuje, jak jsou tyto dv strategie spn, kdy spolu soupe v populaci, kter se vyvj v ase.

JAK TO FUNGUJE?
---------------
V kadm kole vechny krvy spasou jist mnostv trvy z polka, na kterm prv stoj. Pokud je trva pli nzk (ni ne tzv. "rstov prh"), tak dorst mnohem pomaleji, ne pokud je vy. Nenasytn krvy spasou trvu bez ohledu na jej dlku. Spolupracujc krvy nejed trvu, pokud je ni ne je rstov prh. Spolupracujc agent tud nechv vce potravy pro celou populaci za cenu snen krtkodobho osobnho prospchu. Nenasytn agent spase trvu a na holou zem a nebere ohled na dsledky pro celou populaci.
Krvy zachovvaj svoji strategii po cel ivot a jejich potomci po nich strategii dd.   

JAK MODEL OVLDAT
-----------------
START: Zahj a ukon bh modelu.

PIPRAV: Vrt model do potenho stavu podle nastavench parametr. 

POCET-KRAV: Nastav poten poet krav.

POCATECNI-PROCENTO-SPOLUPRACUJICICH: Nastav procento krav, kter budou na potku spolupracovat.

DELKA-KROKU: Tato hodnota ovlivuje pohyb krav. Kad krva se posune v kadm kole o vzdlenost DELKA-KROKU. Pokud se tato hodnota zv, boudou se krvy pohybovat na vt vzdlenost a dky tomu se budou astji pesouvat na jin polka. 

ENERGIE-TRAVY: Pokad kdy krva spase jednotku trvy, vzroste energie krvy o hodnotu danou tmto nastavenm. 

METABOLISMUS: V kadm kole ztrat vechny krvy mnostv energie dan tmto nastavenm. Krva umr, pokud jej energie klesne pod nulu. Kad krva zan se zkladn hodnotou energie 50. To znamen, e me t 50 / METABOLISMUS kol bez pastvy.  

REPRODUKCNI-PRAH: Krva se rozmno, pokud jej energie doshne hodnoty tohoto nastaven. Tato hodnota pedstavuje spch, kterho krva pi hledn potravy mus doshnout, aby se mohla rozmnoit. 

REPRODUKCNI-CENA: Pokad, kdy se krva rozmno, ztrat mnostv energie dan tmto nastavenm. Tato hodnota pedstavuje energetickou cenu (nebo nronost) reprodukce. 

NIZKY-RUST: Tato hodnota pedstavuje pravdpodobnost v procentech, e trva pod rstovm prahem bude dorstat. m vy je tato hodnota, tm men je rozdl mezi dsledky chovn nenasytnch a spolupracujcch krav. 

VYSOKY-RUST: Tato hodnota pedstavuje pravdpodobnost v procentech, e trva nad rstovm prahem bude dorstat. m ni, je tato hodnota, tm men je rozdl mezi dsledky v chovn nenasytnch a spolupracujcch krav. 

MAXIMALNI-VYSKA-TRAVY:  Tato hodnota nastavuje nejvy dlku, do kter me trva dorst.  

RUSTOVY-PRAH:  Tato hodnota nastavuje rstov prh. Trva ni ne rstov prh dorst s pravdpodobnost VYSOKY-RUST. Trva vy ne rstov prh dorst trva s pravdpodobnost NIZKY-RUST. 

VIMNTE SI
-----------
Puste model se zkladnm nastavenm. Sledujte rzn rstov kivky v populanm grafu. Kter populace roste prvn? Kter populace nakonec vyhraje? 

Bude se populace stle zvtovat nebo se po njak dob ustl? Pro?


ZKUSTE SI
---------
Zmn njak vsledek simulace, kdy nastavte POCATECNI-PROCENTO-SPOLUPRACUJICICH na vysokou, ale ne stoprocentn hodnotu (nap. 90%)? 

Pomalu sniujte nastaven DELKA-KROKU. Co se stane s populacemi?

Pi kter hodnot DLKA-KROKU se vvoj populac dramaticky zmn? Co to naznauje ohledn evolun vhody spoluprce oproti nenasytnosti? Jak sloky ivotnho prosted me DLKA-KROKU zastupovat?

Zmte hodnoty METABOLISMUS a CENA-REPRODUKCE. Jak tyto hodnoty ovlivuj model?

Zmte hodnoty ENERGIE-TRAVY, NIZKY-RUST a VYSOKY-RUST. Jak tyto hodnoty ovlivuj model?

Jak ovlivuje hodnota RUSTOVY-PRAH vvoj populac?

Dokete najt nastaven, kter maximln zvhodn spolupracujc krvy?

Dokete najt nastaven, pi kterm se po ase vyvinou spolen jc, relativn stabiln populace spolupracujcch i nenasytnch krav? Kterch bude vce? 

ROZEN MODELU
----------------
Tento model zkoum pouze jeden typ spoluprce, konkrtn spsn trvy pouze nad rstovm prahem. Jak by v tomto modelu mohly fungovat jin typy spoluprce nebo altruistickho chovn, kter sniuj krtkodob individuln zisk, ale pomhaj skupin jako celku.? Jak sloky ivotnho prosted krom dlky trvy mohou ovlivovat zdrav populace.?

Tento model je zvisl zejmna na pohyblivosti populace (DELKA-KROKU). Pokud dlku kroku zvme, povede to k spchu spolupracujcch agent. 
Jak jin promnn mohou mt takto zsadn vliv na evolun spch populac.?

Povimnte si, e chovn agent je v tomto modelu stle stejn. Co by se stalo, kdyby se agenti mohli uit nebo mnit sv chovn podle dostupnosti potravy?


PROGRAMOVAC ZAJMAVOSTI NETLOGA
--------------------------------
Primitivum "breed" bylo pouito k reprezentaci dvou odlinch druh agent. Primitivum "turtle" je pouito k odkazu na oba druhy dohromady. 

SOUVISEJC MODELY
------------------
Altruism


PODKOVN A ODKAZY
-------------------
Tento model a model Altruism jsou soust jendotky EACH "Evolution of Altruistic and Cooperative Habits: Learning About Complexity in Evolution".  Pro vce informac viz http://ccl.northwestern.edu/cm/EACH/. 
EACH je zahrnut do vukovho programu BEAGLE (Biological Experiments in Adaptation, Genetics, Learning and Evolution). Viz http://ccl.northwestern.edu/curriculum/simevolution/beagle.shtml .

Podkovn: Damon Centola, Eamon McKenzie, Josh Mitteldorf, a Scott Styles.

Pi citovn tohoto modelu ve vdeckch publikacch pouijte prosm nsledujc odkaz:  Wilensky, U. (1997).  NetLogo Cooperation model.  http://ccl.northwestern.edu/netlogo/models/Cooperation.  Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.

V jinch publikacch, uvete prosm tyto informace:  Copyright 1997 Uri Wilensky.  All rights reserved.  
Pro dal informace viz http://ccl.northwestern.edu/netlogo/models/Cooperation .

@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 4.0.3
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
